<center><a href="fieldsplit.c">Actual source code: fieldsplit.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:28:41+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>

<a name="line5">  5: </a><font color="#B22222">*/</font>
<a name="line6"> 6: </a> #include <A href="../../../../../include/private/pcimpl.h.html">private/pcimpl.h</A>

<a name="line8">  8: </a><font color="#4169E1">typedef struct _PC_FieldSplitLink *PC_FieldSplitLink;</font>
<a name="line9">  9: </a><font color="#4169E1"><a name="_PC_FieldSplitLink"></a>struct _PC_FieldSplitLink </font>{
<a name="line10"> 10: </a>  <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>               ksp;
<a name="line11"> 11: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>               x,y;
<a name="line12"> 12: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          nfields;
<a name="line13"> 13: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          *fields;
<a name="line14"> 14: </a>  <A href="../../../../../docs/manualpages/Vec/VecScatter.html#VecScatter">VecScatter</A>        sctx;
<a name="line15"> 15: </a>  PC_FieldSplitLink next;
<a name="line16"> 16: </a>};

<a name="line18"> 18: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/PC/PCCompositeType.html#PCCompositeType">PCCompositeType</A>   type;              <font color="#B22222">/* additive or multiplicative */</font>
<a name="line20"> 20: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        defaultsplit;
<a name="line21"> 21: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          bs;
<a name="line22"> 22: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          nsplits,*csize;
<a name="line23"> 23: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>               *x,*y,w1,w2;
<a name="line24"> 24: </a>  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>               *pmat;
<a name="line25"> 25: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>                *is,*cis;
<a name="line26"> 26: </a>  PC_FieldSplitLink head;
<a name="line27"> 27: </a>} PC_FieldSplit;

<a name="line31"> 31: </a><strong><font color="#4169E1"><a name="PCView_FieldSplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCView_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line32"> 32: </a>{
<a name="line33"> 33: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line34"> 34: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line35"> 35: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        iascii;
<a name="line36"> 36: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          i,j;
<a name="line37"> 37: </a>  PC_FieldSplitLink ilink = jac-&gt;head;

<a name="line40"> 40: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_ASCII,&amp;iascii);
<a name="line41"> 41: </a>  <font color="#4169E1">if</font> (iascii) {
<a name="line42"> 42: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  FieldSplit with %s composition: total splits = %D\n"</font>,PCCompositeTypes[jac-&gt;type],jac-&gt;nsplits);
<a name="line43"> 43: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Solver info for each split is in the following <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> objects:\n"</font>);
<a name="line44"> 44: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPushTab.html#PetscViewerASCIIPushTab">PetscViewerASCIIPushTab</A>(viewer);
<a name="line45"> 45: </a>    <font color="#4169E1">for</font> (i=0; i&lt;jac-&gt;nsplits; i++) {
<a name="line46"> 46: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"Split number %D Fields "</font>,i);
<a name="line47"> 47: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIUseTabs.html#PetscViewerASCIIUseTabs">PetscViewerASCIIUseTabs</A>(viewer,<A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>);
<a name="line48"> 48: </a>      <font color="#4169E1">for</font> (j=0; j&lt;ilink-&gt;nfields; j++) {
<a name="line49"> 49: </a>        <font color="#4169E1">if</font> (j &gt; 0) {
<a name="line50"> 50: </a>          <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">","</font>);
<a name="line51"> 51: </a>        }
<a name="line52"> 52: </a>        <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">" %D"</font>,ilink-&gt;fields[j]);
<a name="line53"> 53: </a>      }
<a name="line54"> 54: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"\n"</font>);
<a name="line55"> 55: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIUseTabs.html#PetscViewerASCIIUseTabs">PetscViewerASCIIUseTabs</A>(viewer,<A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line56"> 56: </a>      <A href="../../../../../docs/manualpages/KSP/KSPView.html#KSPView">KSPView</A>(ilink-&gt;ksp,viewer);
<a name="line57"> 57: </a>      ilink = ilink-&gt;next;
<a name="line58"> 58: </a>    }
<a name="line59"> 59: </a>    <A href="../../../../../docs/manualpages/Viewer/PetscViewerASCIIPopTab.html#PetscViewerASCIIPopTab">PetscViewerASCIIPopTab</A>(viewer);
<a name="line60"> 60: </a>  } <font color="#4169E1">else</font> {
<a name="line61"> 61: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Viewer type %s not supported for PCFieldSplit"</font>,((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer)-&gt;type_name);
<a name="line62"> 62: </a>  }
<a name="line63"> 63: </a>  <font color="#4169E1">return</font>(0);
<a name="line64"> 64: </a>}

<a name="line68"> 68: </a><strong><font color="#4169E1"><a name="PCFieldSplitSetDefaults"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCFieldSplitSetDefaults(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line69"> 69: </a>{
<a name="line70"> 70: </a>  PC_FieldSplit     *jac  = (PC_FieldSplit*)pc-&gt;data;
<a name="line71"> 71: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line72"> 72: </a>  PC_FieldSplitLink ilink = jac-&gt;head;
<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          i;
<a name="line74"> 74: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>        flg = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,*fields;

<a name="line77"> 77: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(pc-&gt;prefix,<font color="#666666">"-pc_fieldsplit_default"</font>,&amp;flg,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line78"> 78: </a>  <font color="#4169E1">if</font> (!ilink || flg) {
<a name="line79"> 79: </a>    <A href="../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(pc,<font color="#666666">"Using default splitting of fields\n"</font>);
<a name="line80"> 80: </a>    <font color="#4169E1">if</font> (jac-&gt;bs &lt;= 0) {
<a name="line81"> 81: </a>      <A href="../../../../../docs/manualpages/Mat/MatGetBlockSize.html#MatGetBlockSize">MatGetBlockSize</A>(pc-&gt;pmat,&amp;jac-&gt;bs);
<a name="line82"> 82: </a>    }
<a name="line83"> 83: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(jac-&gt;bs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>),&amp;fields);
<a name="line84"> 84: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(fields,jac-&gt;bs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>));
<a name="line85"> 85: </a>    <font color="#4169E1">while</font> (ilink) {
<a name="line86"> 86: </a>      <font color="#4169E1">for</font> (i=0; i&lt;ilink-&gt;nfields; i++) {
<a name="line87"> 87: </a>        fields[ilink-&gt;fields[i]] = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line88"> 88: </a>      }
<a name="line89"> 89: </a>      ilink = ilink-&gt;next;
<a name="line90"> 90: </a>    }
<a name="line91"> 91: </a>    jac-&gt;defaultsplit = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line92"> 92: </a>    <font color="#4169E1">for</font> (i=0; i&lt;jac-&gt;bs; i++) {
<a name="line93"> 93: </a>      <font color="#4169E1">if</font> (!fields[i]) {
<a name="line94"> 94: </a>        <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A>(pc,1,&amp;i);
<a name="line95"> 95: </a>      } <font color="#4169E1">else</font> {
<a name="line96"> 96: </a>        jac-&gt;defaultsplit = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line97"> 97: </a>      }
<a name="line98"> 98: </a>    }
<a name="line99"> 99: </a>  }
<a name="line100">100: </a>  <font color="#4169E1">return</font>(0);
<a name="line101">101: </a>}


<a name="line106">106: </a><strong><font color="#4169E1"><a name="PCSetUp_FieldSplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetUp_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line107">107: </a>{
<a name="line108">108: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line109">109: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line110">110: </a>  PC_FieldSplitLink ilink;
<a name="line111">111: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          i,nsplit,ccsize;
<a name="line112">112: </a>  <A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>      flag = pc-&gt;flag;

<a name="line115">115: </a>  PCFieldSplitSetDefaults(pc);
<a name="line116">116: </a>  nsplit = jac-&gt;nsplits;
<a name="line117">117: </a>  ilink  = jac-&gt;head;

<a name="line119">119: </a>  <font color="#B22222">/* get the matrices for each split */</font>
<a name="line120">120: </a>  <font color="#4169E1">if</font> (!jac-&gt;is) {
<a name="line121">121: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> rstart,rend,nslots,bs;

<a name="line123">123: </a>    <A href="../../../../../docs/manualpages/Mat/MatGetBlockSize.html#MatGetBlockSize">MatGetBlockSize</A>(pc-&gt;pmat,&amp;bs);
<a name="line124">124: </a>    <A href="../../../../../docs/manualpages/Mat/MatGetOwnershipRange.html#MatGetOwnershipRange">MatGetOwnershipRange</A>(pc-&gt;pmat,&amp;rstart,&amp;rend);
<a name="line125">125: </a>    <A href="../../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(pc-&gt;pmat,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;ccsize);
<a name="line126">126: </a>    nslots = (rend - rstart)/bs;
<a name="line127">127: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nsplit*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>),&amp;jac-&gt;is);
<a name="line128">128: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nsplit*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>),&amp;jac-&gt;cis);
<a name="line129">129: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nsplit*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;jac-&gt;csize);
<a name="line130">130: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nsplit; i++) {
<a name="line131">131: </a>      <font color="#4169E1">if</font> (jac-&gt;defaultsplit) {
<a name="line132">132: </a>        <A href="../../../../../docs/manualpages/IS/ISCreateStride.html#ISCreateStride">ISCreateStride</A>(pc-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,nslots,rstart+i,nsplit,&amp;jac-&gt;is[i]);
<a name="line133">133: </a>        <font color="#4169E1">if</font> (bs != nsplit) <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_PLIB,<font color="#666666">"With default-split the number of fields %D must equal the matrix block <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> %D"</font>,nsplit,bs);
<a name="line134">134: </a>        jac-&gt;csize[i] = ccsize/nsplit;
<a name="line135">135: </a>      } <font color="#4169E1">else</font> {
<a name="line136">136: </a>        <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   *ii,j,k,nfields = ilink-&gt;nfields,*fields = ilink-&gt;fields;
<a name="line137">137: </a>        <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> sorted;
<a name="line138">138: </a>        <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(ilink-&gt;nfields*nslots*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ii);
<a name="line139">139: </a>        <font color="#4169E1">for</font> (j=0; j&lt;nslots; j++) {
<a name="line140">140: </a>          <font color="#4169E1">for</font> (k=0; k&lt;nfields; k++) {
<a name="line141">141: </a>            ii[nfields*j + k] = rstart + bs*j + fields[k];
<a name="line142">142: </a>          }
<a name="line143">143: </a>        }
<a name="line144">144: </a>        <A href="../../../../../docs/manualpages/IS/ISCreateGeneral.html#ISCreateGeneral">ISCreateGeneral</A>(pc-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,nslots*nfields,ii,&amp;jac-&gt;is[i]);
<a name="line145">145: </a>        jac-&gt;csize[i] = (ccsize/bs)*ilink-&gt;nfields;
<a name="line146">146: </a>        <A href="../../../../../docs/manualpages/IS/ISSorted.html#ISSorted">ISSorted</A>(jac-&gt;is[i],&amp;sorted);
<a name="line147">147: </a>        <font color="#4169E1">if</font> (!sorted) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_USER,<font color="#666666">"Fields must be sorted when creating split"</font>);
<a name="line148">148: </a>        <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(ii);
<a name="line149">149: </a>        ilink = ilink-&gt;next;
<a name="line150">150: </a>      }
<a name="line151">151: </a>      <A href="../../../../../docs/manualpages/IS/ISAllGather.html#ISAllGather">ISAllGather</A>(jac-&gt;is[i],&amp;jac-&gt;cis[i]);
<a name="line152">152: </a>    }
<a name="line153">153: </a>  }
<a name="line154">154: </a>
<a name="line155">155: </a>  <font color="#4169E1">if</font> (!jac-&gt;pmat) {
<a name="line156">156: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nsplit*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>),&amp;jac-&gt;pmat);
<a name="line157">157: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nsplit; i++) {
<a name="line158">158: </a>      <A href="../../../../../docs/manualpages/Mat/MatGetSubMatrix.html#MatGetSubMatrix">MatGetSubMatrix</A>(pc-&gt;pmat,jac-&gt;is[i],jac-&gt;cis[i],jac-&gt;csize[i],MAT_INITIAL_MATRIX,&amp;jac-&gt;pmat[i]);
<a name="line159">159: </a>    }
<a name="line160">160: </a>  } <font color="#4169E1">else</font> {
<a name="line161">161: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nsplit; i++) {
<a name="line162">162: </a>      <A href="../../../../../docs/manualpages/Mat/MatGetSubMatrix.html#MatGetSubMatrix">MatGetSubMatrix</A>(pc-&gt;pmat,jac-&gt;is[i],jac-&gt;cis[i],jac-&gt;csize[i],MAT_REUSE_MATRIX,&amp;jac-&gt;pmat[i]);
<a name="line163">163: </a>    }
<a name="line164">164: </a>  }

<a name="line166">166: </a>  <font color="#B22222">/* set up the individual PCs */</font>
<a name="line167">167: </a>  i    = 0;
<a name="line168">168: </a>  ilink = jac-&gt;head;
<a name="line169">169: </a>  <font color="#4169E1">while</font> (ilink) {
<a name="line170">170: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ilink-&gt;ksp,jac-&gt;pmat[i],jac-&gt;pmat[i],flag);
<a name="line171">171: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(ilink-&gt;ksp);
<a name="line172">172: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetUp.html#KSPSetUp">KSPSetUp</A>(ilink-&gt;ksp);
<a name="line173">173: </a>    i++;
<a name="line174">174: </a>    ilink = ilink-&gt;next;
<a name="line175">175: </a>  }
<a name="line176">176: </a>
<a name="line177">177: </a>  <font color="#B22222">/* create work vectors for each split */</font>
<a name="line178">178: </a>  <font color="#4169E1">if</font> (!jac-&gt;x) {
<a name="line179">179: </a>    <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xtmp;
<a name="line180">180: </a>    <A href="../../../../../docs/manualpages/Sys/PetscMalloc2.html#PetscMalloc2">PetscMalloc2</A>(nsplit,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,&amp;jac-&gt;x,nsplit,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,&amp;jac-&gt;y);
<a name="line181">181: </a>    ilink = jac-&gt;head;
<a name="line182">182: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nsplit; i++) {
<a name="line183">183: </a>      <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> *vl,*vr;

<a name="line185">185: </a>      <A href="../../../../../docs/manualpages/KSP/KSPGetVecs.html#KSPGetVecs">KSPGetVecs</A>(ilink-&gt;ksp,1,&amp;vr,1,&amp;vl);
<a name="line186">186: </a>      ilink-&gt;x  = *vr;
<a name="line187">187: </a>      ilink-&gt;y  = *vl;
<a name="line188">188: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(vr);
<a name="line189">189: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(vl);
<a name="line190">190: </a>      jac-&gt;x[i] = ilink-&gt;x;
<a name="line191">191: </a>      jac-&gt;y[i] = ilink-&gt;y;
<a name="line192">192: </a>      ilink     = ilink-&gt;next;
<a name="line193">193: </a>    }
<a name="line194">194: </a>    <font color="#B22222">/* compute scatter contexts needed by multiplicative versions and non-default splits */</font>
<a name="line195">195: </a>
<a name="line196">196: </a>    ilink = jac-&gt;head;
<a name="line197">197: </a>    <A href="../../../../../docs/manualpages/Mat/MatGetVecs.html#MatGetVecs">MatGetVecs</A>(pc-&gt;pmat,&amp;xtmp,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line198">198: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nsplit; i++) {
<a name="line199">199: </a>      <A href="../../../../../docs/manualpages/Vec/VecScatterCreate.html#VecScatterCreate">VecScatterCreate</A>(xtmp,jac-&gt;is[i],jac-&gt;x[i],<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;ilink-&gt;sctx);
<a name="line200">200: </a>      ilink = ilink-&gt;next;
<a name="line201">201: </a>    }
<a name="line202">202: </a>    <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(xtmp);
<a name="line203">203: </a>  }
<a name="line204">204: </a>  <font color="#4169E1">return</font>(0);
<a name="line205">205: </a>}

<a name="line207">207: </a><strong><font color="#228B22">#define FieldSplitSplitSolveAdd(ilink,xx,yy) \</font></strong>
<a name="line208">208: </a><strong><font color="#228B22">    (<A href="../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(xx,ilink-&gt;x,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,ilink-&gt;sctx) || \</font></strong>
<a name="line209">209: </a><strong><font color="#228B22">     <A href="../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>(xx,ilink-&gt;x,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,ilink-&gt;sctx) || \</font></strong>
<a name="line210">210: </a><strong><font color="#228B22">     <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ilink-&gt;ksp,ilink-&gt;x,ilink-&gt;y) || \</font></strong>
<a name="line211">211: </a><strong><font color="#228B22">     <A href="../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(ilink-&gt;y,yy,<A href="../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,ilink-&gt;sctx) || \</font></strong>
<a name="line212">212: </a><strong><font color="#228B22">     <A href="../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>(ilink-&gt;y,yy,<A href="../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,ilink-&gt;sctx))</font></strong>

<a name="line216">216: </a><strong><font color="#4169E1"><a name="PCApply_FieldSplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line217">217: </a>{
<a name="line218">218: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line219">219: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line220">220: </a>  PC_FieldSplitLink ilink = jac-&gt;head;
<a name="line221">221: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          bs;

<a name="line224">224: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetBlockSize.html#VecGetBlockSize">VecGetBlockSize</A>(x,&amp;bs);
<a name="line225">225: </a>  <font color="#4169E1">if</font> (bs != jac-&gt;bs) {
<a name="line226">226: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_ARG_SIZ,<font color="#666666">"Vector blocksize %D does not match Fieldsplit blocksize %D"</font>,bs,jac-&gt;bs);
<a name="line227">227: </a>  }
<a name="line228">228: </a>  <font color="#4169E1">if</font> (jac-&gt;type == PC_COMPOSITE_ADDITIVE) {
<a name="line229">229: </a>    <font color="#4169E1">if</font> (jac-&gt;defaultsplit) {
<a name="line230">230: </a>      <A href="../../../../../docs/manualpages/Vec/VecStrideGatherAll.html#VecStrideGatherAll">VecStrideGatherAll</A>(x,jac-&gt;x,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line231">231: </a>      <font color="#4169E1">while</font> (ilink) {
<a name="line232">232: </a>        <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ilink-&gt;ksp,ilink-&gt;x,ilink-&gt;y);
<a name="line233">233: </a>        ilink = ilink-&gt;next;
<a name="line234">234: </a>      }
<a name="line235">235: </a>      <A href="../../../../../docs/manualpages/Vec/VecStrideScatterAll.html#VecStrideScatterAll">VecStrideScatterAll</A>(jac-&gt;y,y,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line236">236: </a>    } <font color="#4169E1">else</font> {
<a name="line237">237: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    i = 0;

<a name="line239">239: </a>      <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(y,0.0);
<a name="line240">240: </a>      <font color="#4169E1">while</font> (ilink) {
<a name="line241">241: </a>        FieldSplitSplitSolveAdd(ilink,x,y);
<a name="line242">242: </a>        ilink = ilink-&gt;next;
<a name="line243">243: </a>        i++;
<a name="line244">244: </a>      }
<a name="line245">245: </a>    }
<a name="line246">246: </a>  } <font color="#4169E1">else</font> {
<a name="line247">247: </a>    <font color="#4169E1">if</font> (!jac-&gt;w1) {
<a name="line248">248: </a>      <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;jac-&gt;w1);
<a name="line249">249: </a>      <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;jac-&gt;w2);
<a name="line250">250: </a>    }
<a name="line251">251: </a>    <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(y,0.0);
<a name="line252">252: </a>    FieldSplitSplitSolveAdd(ilink,x,y);
<a name="line253">253: </a>    <font color="#4169E1">while</font> (ilink-&gt;next) {
<a name="line254">254: </a>      ilink = ilink-&gt;next;
<a name="line255">255: </a>      <A href="../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(pc-&gt;pmat,y,jac-&gt;w1);
<a name="line256">256: </a>      <A href="../../../../../docs/manualpages/Vec/VecWAXPY.html#VecWAXPY">VecWAXPY</A>(jac-&gt;w2,-1.0,jac-&gt;w1,x);
<a name="line257">257: </a>      FieldSplitSplitSolveAdd(ilink,jac-&gt;w2,y);
<a name="line258">258: </a>    }
<a name="line259">259: </a>  }
<a name="line260">260: </a>  <font color="#4169E1">return</font>(0);
<a name="line261">261: </a>}

<a name="line265">265: </a><strong><font color="#4169E1"><a name="PCDestroy_FieldSplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCDestroy_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line266">266: </a>{
<a name="line267">267: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line268">268: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line269">269: </a>  PC_FieldSplitLink ilink = jac-&gt;head,next;

<a name="line272">272: </a>  <font color="#4169E1">while</font> (ilink) {
<a name="line273">273: </a>    <A href="../../../../../docs/manualpages/KSP/KSPDestroy.html#KSPDestroy">KSPDestroy</A>(ilink-&gt;ksp);
<a name="line274">274: </a>    <font color="#4169E1">if</font> (ilink-&gt;x) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(ilink-&gt;x);}
<a name="line275">275: </a>    <font color="#4169E1">if</font> (ilink-&gt;y) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(ilink-&gt;y);}
<a name="line276">276: </a>    <font color="#4169E1">if</font> (ilink-&gt;sctx) {<A href="../../../../../docs/manualpages/Vec/VecScatterDestroy.html#VecScatterDestroy">VecScatterDestroy</A>(ilink-&gt;sctx);}
<a name="line277">277: </a>    next = ilink-&gt;next;
<a name="line278">278: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree2.html#PetscFree2">PetscFree2</A>(ilink,ilink-&gt;fields);
<a name="line279">279: </a>    ilink = next;
<a name="line280">280: </a>  }
<a name="line281">281: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree2.html#PetscFree2">PetscFree2</A>(jac-&gt;x,jac-&gt;y);
<a name="line282">282: </a>  <font color="#4169E1">if</font> (jac-&gt;pmat) {<A href="../../../../../docs/manualpages/Mat/MatDestroyMatrices.html#MatDestroyMatrices">MatDestroyMatrices</A>(jac-&gt;nsplits,&amp;jac-&gt;pmat);}
<a name="line283">283: </a>  <font color="#4169E1">if</font> (jac-&gt;is) {
<a name="line284">284: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i;
<a name="line285">285: </a>    <font color="#4169E1">for</font> (i=0; i&lt;jac-&gt;nsplits; i++) {<A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(jac-&gt;is[i]);}
<a name="line286">286: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(jac-&gt;is);
<a name="line287">287: </a>  }
<a name="line288">288: </a>  <font color="#4169E1">if</font> (jac-&gt;cis) {
<a name="line289">289: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i;
<a name="line290">290: </a>    <font color="#4169E1">for</font> (i=0; i&lt;jac-&gt;nsplits; i++) {<A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(jac-&gt;cis[i]);}
<a name="line291">291: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(jac-&gt;cis);
<a name="line292">292: </a>  }
<a name="line293">293: </a>  <font color="#4169E1">if</font> (jac-&gt;w1) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(jac-&gt;w1);}
<a name="line294">294: </a>  <font color="#4169E1">if</font> (jac-&gt;w2) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(jac-&gt;w2);}
<a name="line295">295: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(jac-&gt;csize);
<a name="line296">296: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(jac);
<a name="line297">297: </a>  <font color="#4169E1">return</font>(0);
<a name="line298">298: </a>}

<a name="line302">302: </a><strong><font color="#4169E1"><a name="PCSetFromOptions_FieldSplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetFromOptions_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line303">303: </a>{
<a name="line305">305: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i = 0,nfields,fields[12];
<a name="line306">306: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line307">307: </a>  char           optionname[128];
<a name="line308">308: </a>  PC_FieldSplit  *jac = (PC_FieldSplit*)pc-&gt;data;

<a name="line311">311: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHead.html#PetscOptionsHead">PetscOptionsHead</A>(<font color="#666666">"FieldSplit options"</font>);
<a name="line312">312: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsEnum.html#PetscOptionsEnum">PetscOptionsEnum</A>(<font color="#666666">"-pc_fieldsplit_type"</font>,<font color="#666666">"Type of composition"</font>,<font color="#666666">"<A href="../../../../../docs/manualpages/PC/PCFieldSplitSetType.html#PCFieldSplitSetType">PCFieldSplitSetType</A>"</font>,PCCompositeTypes,(<A href="../../../../../docs/manualpages/Sys/PetscEnum.html#PetscEnum">PetscEnum</A>)jac-&gt;type,(<A href="../../../../../docs/manualpages/Sys/PetscEnum.html#PetscEnum">PetscEnum</A>*)&amp;jac-&gt;type,&amp;flg);
<a name="line313">313: </a>  <font color="#4169E1">while</font> (<A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>) {
<a name="line314">314: </a>    sprintf(optionname,<font color="#666666">"-pc_fieldsplit_%d_fields"</font>,(int)i++);
<a name="line315">315: </a>    nfields = 12;
<a name="line316">316: </a>    <A href="../../../../../docs/manualpages/Sys/PetscOptionsIntArray.html#PetscOptionsIntArray">PetscOptionsIntArray</A>(optionname,<font color="#666666">"Fields in this split"</font>,<font color="#666666">"<A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A>"</font>,fields,&amp;nfields,&amp;flg);
<a name="line317">317: </a>    <font color="#4169E1">if</font> (!flg) <font color="#4169E1">break</font>;
<a name="line318">318: </a>    <font color="#4169E1">if</font> (!nfields) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_USER,<font color="#666666">"Cannot list zero fields"</font>);
<a name="line319">319: </a>    <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A>(pc,nfields,fields);
<a name="line320">320: </a>  }
<a name="line321">321: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsTail.html#PetscOptionsTail">PetscOptionsTail</A>();
<a name="line322">322: </a>  <font color="#4169E1">return</font>(0);
<a name="line323">323: </a>}

<a name="line325">325: </a><font color="#B22222">/*------------------------------------------------------------------------------------*/</font>

<a name="line330">330: </a><strong><font color="#4169E1"><a name="PCFieldSplitSetFields_FieldSplit"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFieldSplitSetFields_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *fields)</font></strong>
<a name="line331">331: </a>{
<a name="line332">332: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line333">333: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line334">334: </a>  PC_FieldSplitLink ilink,next = jac-&gt;head;
<a name="line335">335: </a>  char              prefix[128];

<a name="line338">338: </a>  <font color="#4169E1">if</font> (n &lt;= 0) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_OUTOFRANGE,<font color="#666666">"Negative number of fields requested"</font>);
<a name="line339">339: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc2.html#PetscMalloc2">PetscMalloc2</A>(1,<font color="#4169E1">struct _PC_FieldSplitLink</font>,&amp;ilink,n,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,&amp;ilink-&gt;fields);
<a name="line340">340: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(ilink-&gt;fields,fields,n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line341">341: </a>  ilink-&gt;nfields = n;
<a name="line342">342: </a>  ilink-&gt;next    = <A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>;
<a name="line343">343: </a>  <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(pc-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;ilink-&gt;ksp);
<a name="line344">344: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(ilink-&gt;ksp,<A href="../../../../../docs/manualpages/KSP/KSPPREONLY.html#KSPPREONLY">KSPPREONLY</A>);

<a name="line346">346: </a>  <font color="#4169E1">if</font> (pc-&gt;prefix) {
<a name="line347">347: </a>    sprintf(prefix,<font color="#666666">"%sfieldsplit_%d_"</font>,pc-&gt;prefix,(int)jac-&gt;nsplits);
<a name="line348">348: </a>  } <font color="#4169E1">else</font> {
<a name="line349">349: </a>    sprintf(prefix,<font color="#666666">"fieldsplit_%d_"</font>,(int)jac-&gt;nsplits);
<a name="line350">350: </a>  }
<a name="line351">351: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetOptionsPrefix.html#KSPSetOptionsPrefix">KSPSetOptionsPrefix</A>(ilink-&gt;ksp,prefix);

<a name="line353">353: </a>  <font color="#4169E1">if</font> (!next) {
<a name="line354">354: </a>    jac-&gt;head = ilink;
<a name="line355">355: </a>  } <font color="#4169E1">else</font> {
<a name="line356">356: </a>    <font color="#4169E1">while</font> (next-&gt;next) {
<a name="line357">357: </a>      next = next-&gt;next;
<a name="line358">358: </a>    }
<a name="line359">359: </a>    next-&gt;next = ilink;
<a name="line360">360: </a>  }
<a name="line361">361: </a>  jac-&gt;nsplits++;
<a name="line362">362: </a>  <font color="#4169E1">return</font>(0);
<a name="line363">363: </a>}


<a name="line370">370: </a><strong><font color="#4169E1"><a name="PCFieldSplitGetSubKSP_FieldSplit"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFieldSplitGetSubKSP_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> **subksp)</font></strong>
<a name="line371">371: </a>{
<a name="line372">372: </a>  PC_FieldSplit     *jac = (PC_FieldSplit*)pc-&gt;data;
<a name="line373">373: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>    ierr;
<a name="line374">374: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>          cnt = 0;
<a name="line375">375: </a>  PC_FieldSplitLink ilink = jac-&gt;head;

<a name="line378">378: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(jac-&gt;nsplits*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>*),subksp);
<a name="line379">379: </a>  <font color="#4169E1">while</font> (ilink) {
<a name="line380">380: </a>    (*subksp)[cnt++] = ilink-&gt;ksp;
<a name="line381">381: </a>    ilink = ilink-&gt;next;
<a name="line382">382: </a>  }
<a name="line383">383: </a>  <font color="#4169E1">if</font> (cnt != jac-&gt;nsplits) <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_PLIB,<font color="#666666">"Corrupt <A href="../../../../../docs/manualpages/PC/PCFIELDSPLIT.html#PCFIELDSPLIT">PCFIELDSPLIT</A> object: number splits in linked list %D in object %D"</font>,cnt,jac-&gt;nsplits);
<a name="line384">384: </a>  *n = jac-&gt;nsplits;
<a name="line385">385: </a>  <font color="#4169E1">return</font>(0);
<a name="line386">386: </a>}

<a name="line391">391: </a><font color="#B22222">/*@</font>
<a name="line392">392: </a><font color="#B22222">    <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A> - Sets the fields for one particular split in the field split preconditioner</font>

<a name="line394">394: </a><font color="#B22222">    Collective on <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line396">396: </a><font color="#B22222">    Input Parameters:</font>
<a name="line397">397: </a><font color="#B22222">+   pc  - the preconditioner context</font>
<a name="line398">398: </a><font color="#B22222">.   n - the number of fields in this split</font>
<a name="line399">399: </a><font color="#B22222">.   fields - the fields in this split</font>

<a name="line401">401: </a><font color="#B22222">    Level: intermediate</font>

<a name="line403">403: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>(), <A href="../../../../../docs/manualpages/PC/PCFIELDSPLIT.html#PCFIELDSPLIT">PCFIELDSPLIT</A></font>

<a name="line405">405: </a><font color="#B22222">@*/</font>
<a name="line406">406: </a><strong><font color="#4169E1"><a name="PCFieldSplitSetFields"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A>(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n, <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *fields)</font></strong>
<a name="line407">407: </a>{
<a name="line408">408: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *);

<a name="line412">412: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitSetFields_C"</font>,(void (**)(void))&amp;f);
<a name="line413">413: </a>  <font color="#4169E1">if</font> (f) {
<a name="line414">414: </a>    (*f)(pc,n,fields);
<a name="line415">415: </a>  }
<a name="line416">416: </a>  <font color="#4169E1">return</font>(0);
<a name="line417">417: </a>}

<a name="line421">421: </a><font color="#B22222">/*@C</font>
<a name="line422">422: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A> - Gets the <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> contexts for all splits</font>
<a name="line423">423: </a><font color="#B22222">   </font>
<a name="line424">424: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A></font>

<a name="line426">426: </a><font color="#B22222">   Input Parameter:</font>
<a name="line427">427: </a><font color="#B22222">.  pc - the preconditioner context</font>

<a name="line429">429: </a><font color="#B22222">   Output Parameters:</font>
<a name="line430">430: </a><font color="#B22222">+  n - the number of split</font>
<a name="line431">431: </a><font color="#B22222">-  pc - the array of <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> contexts</font>

<a name="line433">433: </a><font color="#B22222">   Note:  </font>
<a name="line434">434: </a><font color="#B22222">   After <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>() the array of KSPs <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> to be freed</font>

<a name="line436">436: </a><font color="#B22222">   You must call <A href="../../../../../docs/manualpages/KSP/KSPSetUp.html#KSPSetUp">KSPSetUp</A>() before calling <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>().</font>

<a name="line438">438: </a><font color="#B22222">   Level: advanced</font>

<a name="line440">440: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/PC/PCFIELDSPLIT.html#PCFIELDSPLIT">PCFIELDSPLIT</A></font>
<a name="line441">441: </a><font color="#B22222">@*/</font>
<a name="line442">442: </a><strong><font color="#4169E1"><a name="PCFieldSplitGetSubKSP"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> *subksp[])</font></strong>
<a name="line443">443: </a>{
<a name="line444">444: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*,<A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> **);

<a name="line449">449: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitGetSubKSP_C"</font>,(void (**)(void))&amp;f);
<a name="line450">450: </a>  <font color="#4169E1">if</font> (f) {
<a name="line451">451: </a>    (*f)(pc,n,subksp);
<a name="line452">452: </a>  } <font color="#4169E1">else</font> {
<a name="line453">453: </a>    <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Cannot get subksp for this type of <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>"</font>);
<a name="line454">454: </a>  }
<a name="line455">455: </a>  <font color="#4169E1">return</font>(0);
<a name="line456">456: </a>}

<a name="line461">461: </a><strong><font color="#4169E1"><a name="PCFieldSplitSetType_FieldSplit"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFieldSplitSetType_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/PC/PCCompositeType.html#PCCompositeType">PCCompositeType</A> type)</font></strong>
<a name="line462">462: </a>{
<a name="line463">463: </a>  PC_FieldSplit  *jac = (PC_FieldSplit*)pc-&gt;data;

<a name="line466">466: </a>  jac-&gt;type = type;
<a name="line467">467: </a>  <font color="#4169E1">return</font>(0);
<a name="line468">468: </a>}

<a name="line473">473: </a><font color="#B22222">/*@C</font>
<a name="line474">474: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetType.html#PCFieldSplitSetType">PCFieldSplitSetType</A> - Sets the type of fieldsplit preconditioner.</font>
<a name="line475">475: </a><font color="#B22222">   </font>
<a name="line476">476: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line478">478: </a><font color="#B22222">   Input Parameter:</font>
<a name="line479">479: </a><font color="#B22222">.  pc - the preconditioner context</font>
<a name="line480">480: </a><font color="#B22222">.  type - PC_COMPOSITE_ADDITIVE (default), PC_COMPOSITE_MULTIPLICATIVE</font>

<a name="line482">482: </a><font color="#B22222">   Options Database Key:</font>
<a name="line483">483: </a><font color="#B22222">.  -pc_fieldsplit_type &lt;type: one of multiplicative, additive, special&gt; - Sets fieldsplit preconditioner type</font>

<a name="line485">485: </a><font color="#B22222">   Level: Developer</font>

<a name="line487">487: </a><font color="#B22222">.keywords: <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>, set, type, composite preconditioner, additive, multiplicative</font>

<a name="line489">489: </a><font color="#B22222">.seealso: <A href="../../../../../docs/manualpages/PC/PCCompositeSetType.html#PCCompositeSetType">PCCompositeSetType</A>()</font>

<a name="line491">491: </a><font color="#B22222">@*/</font>
<a name="line492">492: </a><strong><font color="#4169E1"><a name="PCFieldSplitSetType"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetType.html#PCFieldSplitSetType">PCFieldSplitSetType</A>(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/PC/PCCompositeType.html#PCCompositeType">PCCompositeType</A> type)</font></strong>
<a name="line493">493: </a>{
<a name="line494">494: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../docs/manualpages/PC/PCCompositeType.html#PCCompositeType">PCCompositeType</A>);

<a name="line498">498: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitSetType_C"</font>,(void (**)(void))&amp;f);
<a name="line499">499: </a>  <font color="#4169E1">if</font> (f) {
<a name="line500">500: </a>    (*f)(pc,type);
<a name="line501">501: </a>  }
<a name="line502">502: </a>  <font color="#4169E1">return</font>(0);
<a name="line503">503: </a>}

<a name="line505">505: </a><font color="#B22222">/* -------------------------------------------------------------------------------------*/</font>
<a name="line506">506: </a><font color="#B22222">/*MC</font>
<a name="line507">507: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/PC/PCFIELDSPLIT.html#PCFIELDSPLIT">PCFIELDSPLIT</A> - Preconditioner created by combining separate preconditioners for individual</font>
<a name="line508">508: </a><font color="#B22222">                  fields or groups of fields</font>


<a name="line511">511: </a><font color="#B22222">     To set options on the solvers for each block append -sub_ to all the <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>
<a name="line512">512: </a><font color="#B22222">        options database keys. For example, -sub_pc_type ilu -sub_pc_factor_levels 1</font>
<a name="line513">513: </a><font color="#B22222">        </font>
<a name="line514">514: </a><font color="#B22222">     To set the options on the solvers separate for each block call <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>()</font>
<a name="line515">515: </a><font color="#B22222">         and set the options directly on the resulting <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> object</font>

<a name="line517">517: </a><font color="#B22222">   Level: intermediate</font>

<a name="line519">519: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line520">520: </a><font color="#B22222">+   -pc_splitfield_%d_fields &lt;a,b,..&gt; - indicates the fields to be used in the %d'th split</font>
<a name="line521">521: </a><font color="#B22222">.   -pc_splitfield_default - automatically add any fields to additional splits that have not</font>
<a name="line522">522: </a><font color="#B22222">                              been supplied explicitly by -pc_splitfield_%d_fields</font>
<a name="line523">523: </a><font color="#B22222">-   -pc_splitfield_type &lt;additive,multiplicative&gt;</font>

<a name="line525">525: </a><font color="#B22222">   Concepts: physics based preconditioners</font>

<a name="line527">527: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(), <A href="../../../../../docs/manualpages/PC/PCType.html#PCType">PCType</A> (for list of available types), <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,</font>
<a name="line528">528: </a><font color="#B22222">           <A href="../../../../../docs/manualpages/PC/PCFieldSplitGetSubKSP.html#PCFieldSplitGetSubKSP">PCFieldSplitGetSubKSP</A>(), <A href="../../../../../docs/manualpages/PC/PCFieldSplitSetFields.html#PCFieldSplitSetFields">PCFieldSplitSetFields</A>(),<A href="../../../../../docs/manualpages/PC/PCFieldSplitSetType.html#PCFieldSplitSetType">PCFieldSplitSetType</A>()</font>
<a name="line529">529: </a><font color="#B22222">M*/</font>

<a name="line534">534: </a><strong><font color="#4169E1"><a name="PCCreate_FieldSplit"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCCreate_FieldSplit(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line535">535: </a>{
<a name="line537">537: </a>  PC_FieldSplit  *jac;

<a name="line540">540: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PC_FieldSplit,&amp;jac);
<a name="line541">541: </a>  PetscLogObjectMemory(pc,<font color="#4169E1">sizeof</font>(PC_FieldSplit));
<a name="line542">542: </a>  jac-&gt;bs      = -1;
<a name="line543">543: </a>  jac-&gt;nsplits = 0;
<a name="line544">544: </a>  jac-&gt;type    = PC_COMPOSITE_ADDITIVE;
<a name="line545">545: </a>  pc-&gt;data     = (void*)jac;

<a name="line547">547: </a>  pc-&gt;ops-&gt;apply             = PCApply_FieldSplit;
<a name="line548">548: </a>  pc-&gt;ops-&gt;setup             = PCSetUp_FieldSplit;
<a name="line549">549: </a>  pc-&gt;ops-&gt;destroy           = PCDestroy_FieldSplit;
<a name="line550">550: </a>  pc-&gt;ops-&gt;setfromoptions    = PCSetFromOptions_FieldSplit;
<a name="line551">551: </a>  pc-&gt;ops-&gt;view              = PCView_FieldSplit;
<a name="line552">552: </a>  pc-&gt;ops-&gt;applyrichardson   = 0;

<a name="line554">554: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitGetSubKSP_C"</font>,<font color="#666666">"PCFieldSplitGetSubKSP_FieldSplit"</font>,
<a name="line555">555: </a>                    PCFieldSplitGetSubKSP_FieldSplit);
<a name="line556">556: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitSetFields_C"</font>,<font color="#666666">"PCFieldSplitSetFields_FieldSplit"</font>,
<a name="line557">557: </a>                    PCFieldSplitSetFields_FieldSplit);
<a name="line558">558: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFieldSplitSetType_C"</font>,<font color="#666666">"PCFieldSplitSetType_FieldSplit"</font>,
<a name="line559">559: </a>                    PCFieldSplitSetType_FieldSplit);
<a name="line560">560: </a>  <font color="#4169E1">return</font>(0);
<a name="line561">561: </a>}


</pre>
</body>

</html>
